// SmtpConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SettingDlg.h"
#include "afxdialogex.h"
#include "SvrProcessCtrl.h"


// CSettingDlg dialog

IMPLEMENT_DYNAMIC(CSettingDlg, CDialog)

CSettingDlg::CSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingDlg::IDD, pParent)
	, m_strSmtpServer(_T(""))
	, m_strSenderMail(_T(""))
	, m_strSenderPswd(_T(""))
	, m_strMailTo(_T(""))
	, m_nMinAlertInterval(0)
	, m_nCheckStatusInterval(0)
{

}

CSettingDlg::~CSettingDlg()
{
}

void CSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_SMTP_SERVER, m_strSmtpServer);
	DDX_Text(pDX, IDC_SMTP_PORT, m_strSmtpPort);
	DDX_Text(pDX, IDC_SMTP_ACCOUNT, m_strSenderMail);
	DDX_Text(pDX, IDC_SMTP_PASSWORD, m_strSenderPswd);
	DDX_Text(pDX, IDC_MAILTO, m_strMailTo);
	DDX_Text(pDX, IDC_MIN_ALERT_INTERVAL, m_nMinAlertInterval);
	DDV_MinMaxInt(pDX, m_nMinAlertInterval, 1, 120);
	DDX_Text(pDX, IDC_STATUS_CHECK_INTERVAL, m_nCheckStatusInterval);
}


BEGIN_MESSAGE_MAP(CSettingDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CSettingDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_SMTP_TEST, &CSettingDlg::OnBnClickedSmtpTest)
END_MESSAGE_MAP()


// CSettingDlg message handlers


void CSettingDlg::OnBnClickedOk()
{
	UpdateData();
	CSvrProcessCtrl::SetAlertMailSetting((LPCSTR)m_strSmtpServer, (LPCSTR)m_strSmtpPort, (LPCSTR)m_strSenderMail, (LPCSTR)m_strSenderPswd, (LPCSTR)m_strMailTo, m_nMinAlertInterval);

	CString inifile = GetModuleDir();
	inifile += "\\svrmonitor.ini";
	WritePrivateProfileString("GENERAL", "CHECK_SVR_STATUS_INTERVAL", to_string(m_nCheckStatusInterval).c_str(), inifile);
	WritePrivateProfileString("ALERT_MAIL", "SMTP_SERVER", m_strSmtpServer, inifile);
	WritePrivateProfileString("ALERT_MAIL", "SMTP_PORT", m_strSmtpPort, inifile);
	WritePrivateProfileString("ALERT_MAIL", "SMTP_USER", m_strSenderMail, inifile);
	WritePrivateProfileString("ALERT_MAIL", "SMTP_PASSWORD", m_strSenderPswd, inifile);
	WritePrivateProfileString("ALERT_MAIL", "SMTP_MAILTO", m_strMailTo, inifile);
	WritePrivateProfileString("ALERT_MAIL", "MIN_ALERT_INTERVAL", to_string(m_nMinAlertInterval).c_str(), inifile);

	CDialog::OnOK();
}


BOOL CSettingDlg::OnInitDialog()
{
	AlertMailSetting alertMailSetting = CSvrProcessCtrl::GetAlertMailSetting();

	m_strSmtpServer = alertMailSetting.smtpServer_.c_str();
	m_strSmtpPort = alertMailSetting.smtpPort_.c_str();
	m_strSenderMail = alertMailSetting.smtpUser_.c_str();
	m_strSenderPswd = alertMailSetting.smtpPassword_.c_str();
	m_strMailTo = alertMailSetting.mailTo_.c_str();
	m_nMinAlertInterval = alertMailSetting.minAlertInterval_;

	CDialog::OnInitDialog();	

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CSettingDlg::OnBnClickedSmtpTest()
{
	UpdateData();	

	string errmsg;
	if (!CSvrProcessCtrl::smtp_sendmail((LPCSTR)m_strSmtpServer,
		(LPCSTR)m_strSmtpPort,
		(LPCSTR)m_strSenderMail,
		(LPCSTR)m_strSenderPswd,
		"Minigame SMTP test mail", 
		"SMTP Setting Test Mail", 
		(LPCSTR)m_strMailTo,
		"",
		errmsg))
	{
		AfxMessageBox("ʼʧ!");
	}
	else
	{
		AfxMessageBox("ʼͳɹ '' ťSMTP!");
	}
}
