#include "stdafx.h"
#include "SvrProcessCtrl.h"
#include <sstream>
#include <vector>
#include <algorithm>
#include <functional>
#include "tlhelp32.h"
#include "Iphlpapi.h"
#include "slog.h"

CStatic CSvrProcessCtrl::header1;
CStatic CSvrProcessCtrl::header2;
CStatic CSvrProcessCtrl::header3;
CStatic CSvrProcessCtrl::header4;
CStatic CSvrProcessCtrl::header5;
CStatic CSvrProcessCtrl::header6;
CStatic CSvrProcessCtrl::header7;

CPoint CSvrProcessCtrl::headerTopLeft_(25,30);
int CSvrProcessCtrl::count_ = 0;
CFont CSvrProcessCtrl::m_font;
AlertMailSetting CSvrProcessCtrl::alertMailSetting_;

///////////////////////////////////////

//begin 20180528 add by  罭 

#pragma comment(lib,"psapi.lib") 

typedef struct
{
	USHORT Length;
	USHORT MaximumLength;
	PWSTR  Buffer;
} UNICODE_STRING, *PUNICODE_STRING;

typedef struct
{
	ULONG          AllocationSize;
	ULONG          ActualSize;
	ULONG          Flags;
	ULONG          Unknown1;
	UNICODE_STRING Unknown2;
	HANDLE         InputHandle;
	HANDLE         OutputHandle;
	HANDLE         ErrorHandle;
	UNICODE_STRING CurrentDirectory;
	HANDLE         CurrentDirectoryHandle;
	UNICODE_STRING SearchPaths;
	UNICODE_STRING ApplicationName;
	UNICODE_STRING CommandLine;
	PVOID          EnvironmentBlock;
	ULONG          Unknown[9];
	UNICODE_STRING Unknown3;
	UNICODE_STRING Unknown4;
	UNICODE_STRING Unknown5;
	UNICODE_STRING Unknown6;
} PROCESS_PARAMETERS, *PPROCESS_PARAMETERS;

typedef struct
{
	ULONG               AllocationSize;
	ULONG               Unknown1;
	HINSTANCE           ProcessHinstance;
	PVOID               ListDlls;
	PPROCESS_PARAMETERS ProcessParameters;
	ULONG               Unknown2;
	HANDLE              Heap;
} PEB, *PPEB;

typedef struct
{
	DWORD ExitStatus;
	PPEB  PebBaseAddress;
	DWORD AffinityMask;
	DWORD BasePriority;
	ULONG UniqueProcessId;
	ULONG InheritedFromUniqueProcessId;
}   PROCESS_BASIC_INFORMATION;

typedef LONG(WINAPI *PROCNTQSIP)(HANDLE, UINT, PVOID, ULONG, PULONG);


static BOOL GetProcessCommandLineByPid(const DWORD dwPID, CString& processCmd)
{
#define MAX_BUFFER_SIZE 256
	HANDLE                    hProcess;
	PROCESS_BASIC_INFORMATION pbi;
	PEB                       Peb;
	PROCESS_PARAMETERS        ProcParam;
	DWORD                     dwDummy;
	DWORD                     dwSize;
	LPVOID                    lpAddress;

	BOOL RetValue = FALSE;

	static PROCNTQSIP NtQueryInformationProcess = NULL;
	if (NtQueryInformationProcess == NULL)
	{
		NtQueryInformationProcess = (PROCNTQSIP)GetProcAddress(GetModuleHandle("ntdll"),
			"NtQueryInformationProcess");
		if (!NtQueryInformationProcess)
		{
			g_log->error("get function NtQueryInformationProcess from ntdll error\n");
			goto Ret;
		}
	}

	//õ̾  
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwPID);
	if (!hProcess)
		goto Ret;
	//ȡϢ  
	if (0 != NtQueryInformationProcess(hProcess, 0, (PVOID)&pbi, sizeof(PROCESS_BASIC_INFORMATION), NULL))
		goto Ret;
	if (!ReadProcessMemory(hProcess, pbi.PebBaseAddress, &Peb, sizeof(PEB), (SIZE_T*)&dwDummy))
		goto Ret;
	if (!ReadProcessMemory(hProcess, Peb.ProcessParameters, &ProcParam, sizeof(PROCESS_PARAMETERS), (SIZE_T*)&dwDummy))
		goto Ret;

	lpAddress = ProcParam.CommandLine.Buffer;
	dwSize = ProcParam.CommandLine.Length >= MAX_BUFFER_SIZE ? (MAX_BUFFER_SIZE - 1) : ProcParam.CommandLine.Length;

	wchar_t wCommandLine[MAX_BUFFER_SIZE];
	char szCommandLine[sizeof(wCommandLine)];
	memset(wCommandLine, 0, sizeof(wCommandLine));
	memset(szCommandLine, 0, sizeof(szCommandLine));

	if (!ReadProcessMemory(hProcess, lpAddress, wCommandLine, dwSize, (SIZE_T*)&dwDummy))
		goto Ret;
	WideCharToMultiByte(CP_ACP, NULL, wCommandLine, sizeof(wCommandLine), szCommandLine, sizeof(szCommandLine), NULL, NULL);

	processCmd = szCommandLine;
	processCmd.Remove('\"'); // ȥе˫

	int pos = processCmd.Find(" ");
	if (pos == -1)
		processCmd = "";
	else
		processCmd.Delete(0, pos);

	processCmd.Trim();

	RetValue = true;
Ret:
	if (hProcess)
		CloseHandle(hProcess);
	return RetValue;
}
//end 20180528 add by  罭 
static bool PipeShellCmd(const string& cmd, string& output)
{
	FILE *fp = NULL;
	char szOutput[8192] = { 0 };

	if ((fp = _popen(cmd.c_str(), "r")) == NULL)
	{
		perror("popen error\n");
		return false;
	}

	fread(szOutput, 1, sizeof(szOutput), fp);
	output = szOutput;

	_pclose(fp);

	return true;
}

inline std::string &ltrim(std::string &s) {
	s.erase(s.begin(), std::find_if(s.begin(), s.end(), std::not1(std::ptr_fun<int, int>(isspace))));
	return s;
}
inline std::string &rtrim(std::string &s) {
	s.erase(std::find_if(s.rbegin(), s.rend(), std::not1(std::ptr_fun<int, int>(isspace))).base(), s.end());
	return s;
}
inline std::string &trim(std::string &s) {
	return ltrim(rtrim(s));
}

static void splitString(string strInput, vector<string>& vecStrOut, string delim)
{
	size_t pos = 0;
	string token;
	while ((pos = strInput.find(delim)) != string::npos) {
		token = strInput.substr(0, pos);
		strInput.erase(0, pos + delim.length());
		trim(token);
		if (token.empty())
		{
			continue;
		}

		vecStrOut.push_back(token);
	}
	vecStrOut.push_back(trim(strInput));
}

/*
//ݽpidȡ̵в
SIZE_T WINAPI GetProcessCommandLineByPid(DWORD dwPID, CString& processCmd)
{
	HANDLE hProcess = ::OpenProcess(PROCESS_CREATE_THREAD | PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ, FALSE, dwPID);

	if (!hProcess)
	{
		return 0;
	}

	DWORD dwThreadId = 0;
	DWORD dwExitCode = 0;
	SIZE_T dwReaded = 0;
	HANDLE hThread = ::CreateRemoteThread(hProcess, NULL, NULL, (LPTHREAD_START_ROUTINE)GetCommandLine, NULL, 0, &dwThreadId);
	TCHAR szBuffer[512] = { 0 };

	if (hThread)
	{
		::WaitForSingleObject(hThread, INFINITE);
		::GetExitCodeThread(hThread, &dwExitCode);
		::ReadProcessMemory(hProcess, (LPCVOID)dwExitCode, szBuffer, sizeof(szBuffer), &dwReaded);
	}
	CloseHandle(hProcess);
	CloseHandle(hThread);

	processCmd.Format(_T("%s"), szBuffer);
	processCmd.Remove('\"'); // ȥе˫
	
	int pos = processCmd.Find(" ");
	if (pos == -1)
		processCmd = "";
	else
		processCmd.Delete(0, pos);

	processCmd.Trim();
	
	return dwReaded;
}


//exeļ·ȡPID
int GetPidByFilepath(const CString& processName, const CString& processPath)
{
	PROCESSENTRY32 pe;
	MODULEENTRY32 me;
	DWORD id = 0;
	HANDLE mehandle;

	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	pe.dwSize = sizeof(PROCESSENTRY32);
	BOOL ret = Process32First(hSnapshot, &pe);

	if (!ret)
	{
		return 0;
	}

	while (1)
	{
		pe.dwSize = sizeof(PROCESSENTRY32);

		if (Process32Next(hSnapshot, &pe) == FALSE)

			break;

		if (processName.CompareNoCase(pe.szExeFile) == 0)
		{
			//ȡǰ·
			mehandle = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			me.dwSize = sizeof(MODULEENTRY32);
			Module32First(mehandle, &me);

			if (processPath.CompareNoCase(me.szExePath) == 0)
			{
				id = pe.th32ProcessID;
				break;
			}
		}

	}

	CloseHandle(hSnapshot);

	return id;
}
*/

int GetPid(const CString& processName, const CString& processPath, const CString& processCmd)
{
	PROCESSENTRY32 pe;
	MODULEENTRY32 me;
	DWORD id = 0;
	HANDLE mehandle;

	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	pe.dwSize = sizeof(PROCESSENTRY32);
	BOOL ret = Process32First(hSnapshot, &pe);

	if (!ret)
	{
		return 0;
	}

	while (1)
	{
		pe.dwSize = sizeof(PROCESSENTRY32);

		if (Process32Next(hSnapshot, &pe) == FALSE)
			break;

		if (processName.CompareNoCase(pe.szExeFile) == 0)
		{
			//ȡǰ·
			mehandle = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			me.dwSize = sizeof(MODULEENTRY32);
			Module32First(mehandle, &me);
			CloseHandle(mehandle);

			bool ishf = false;
			if (processPath.CompareNoCase(me.szExePath) == 0)
				ishf = true;
			else
			{
				// ֹ·дһ¶˶
				HANDLE h_Process = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, pe.th32ProcessID);
				char strFilePath[256] = { 0 };
				DWORD size = 256;
				QueryFullProcessImageName(h_Process, NULL, strFilePath, &size);
				CloseHandle(h_Process);
				if (processPath.CompareNoCase(strFilePath) == 0)
					ishf = true;
			}
			if (ishf)
			{
				CString cmd;
				//ȡǰв
				// Ĭgameserver ʱȡ
				// ĬϳʱּصcmdΪ11
				GetProcessCommandLineByPid(pe.th32ProcessID, cmd);
				if (processCmd.Compare(_T("/ServerID 11")) == 0 && cmd.IsEmpty() ||( processCmd.IsEmpty() && cmd.Compare(_T("/ServerID 11")) == 0))
				{
					cmd = processCmd;
				}
				if (processCmd.CompareNoCase(cmd) == 0)
				{
					id = pe.th32ProcessID;
					break;
				}
			}
			else
			{
			}
		}

	}

	CloseHandle(hSnapshot);

	return id;
}

//ݿ̨PIDȡconhost.exeĽPID
int GetConhostPID(long cmdPid)
{
	PROCESSENTRY32 pe;
	MODULEENTRY32 me;
	DWORD pid = 0;
	HANDLE mehandle;
	CString processName = "conhost.exe";

	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	pe.dwSize = sizeof(PROCESSENTRY32);
	BOOL ret = Process32First(hSnapshot, &pe);

	if (!ret)
	{
		return 0;
	}

	while (1)
	{
		pe.dwSize = sizeof(PROCESSENTRY32);

		if (Process32Next(hSnapshot, &pe) == FALSE)

			break;

		if (processName.CompareNoCase(pe.szExeFile) == 0)
		{
			//ȡǰ·
			mehandle = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			me.dwSize = sizeof(MODULEENTRY32);
			Module32First(mehandle, &me);

			if (pe.th32ParentProcessID == cmdPid)
			{
				pid = pe.th32ProcessID;
				break;
			}
		}
	}

	CloseHandle(hSnapshot);

	return pid;
}

std::string IP2Str(const uint32_t ip)
{
	char ip_addr[20] = { 0 };
	std::string dst_ip;
	uint32_t dst_item[4];

	for (int i = 0; i < 4; ++i) {
		dst_item[i] = ((ip >> (i * 8)) & 0xFF);
	}

	_snprintf_s(ip_addr, sizeof(ip_addr), sizeof(ip_addr) - 1, "%d.%d.%d.%d", dst_item[3], dst_item[2], dst_item[1], dst_item[0]);
	dst_ip = ip_addr;

	return std::move(dst_ip);
}
/////////////////////////////////////////

CSvrProcessCtrl::CSvrProcessCtrl(int id, string name, string commandline)
	: serverInfo_(id, name, commandline)
{
	count_++;
}


CSvrProcessCtrl::~CSvrProcessCtrl()
{
	count_--;
}


bool CSvrProcessCtrl::Create(CWnd* parent)
{
	if (isCtrlsCreated_)
	{
		return true;
	}

	CheckProcessStatus();

	if (parent == NULL)
	{
		parent_ = AfxGetMainWnd();
	}
	else
	{
		parent_ = parent;
	}

	int y = headerTopLeft_.y + serverInfo_.id_ * CTRL_HEIGHT;
	int x = headerTopLeft_.x;

	int width = 200;
	int height = CTRL_HEIGHT - 8;
	textName_.Create(serverInfo_.name_.c_str(), WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	textName_.SetFont(&m_font);

	//x += width + 20;
	//width = 180;
	//textProcessName_.Create(serverInfo_.processName_.c_str(), WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	//textProcessName_.SetFont(&m_font);

	x += width + 20;
	width = 480;
	textCommandline_.Create(serverInfo_.commandline_.c_str(), WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	textCommandline_.SetFont(&m_font);

	x += width + 20;
	width = 80;
	textPid_.Create(serverInfo_.pid_== 0 ? "" : to_string(serverInfo_.pid_).c_str(), WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	textPid_.SetFont(&m_font);

	x += width + 20;
	width = 120;
	textListenAddr_.Create(serverInfo_.listenAddr_.c_str(), WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	textListenAddr_.SetFont(&m_font);

	x += width + 20;
	width = 150;
	CString strStartupTime;
	if (serverInfo_.startupTime_ != 0)
	{
		strStartupTime = serverInfo_.startupTime_.Format("%Y-%m-%d %H:%M:%S");
	}
	textStartupTime_.Create(strStartupTime, WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent_);
	textStartupTime_.SetFont(&m_font);

	//ͣButton
	x += width + 20;
	width = 60;
	string btnText = serverInfo_.pid_ > 0 ? "ֹͣ" : "";
	btnStart_.Create(btnText.c_str(), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(x, y, x + width, y + height), parent_, GenStartBtnID());
	btnStart_.SetFont(&m_font);	

	//༭Button
	x += width + 10;
	width = 60;
	btnEdit_.Create("༭", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(x, y, x + width, y + height), parent_, GenEditBtnID());
	btnEdit_.SetFont(&m_font);

	//ɾButton
	x += width + 10;
	width = 60;
	btnDelete_.Create("ɾ", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(x, y, x + width, y + height), parent_, GenDeleteBtnID());
	btnDelete_.SetFont(&m_font);

	//¼Btuuon
	x += width + 10;
	width = 60;
	btnReLoadCfg_.Create("", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(x, y, x + width, y + height), parent_, GenReLoadCfgBtnID());
	btnReLoadCfg_.SetFont(&m_font);

	//򿪳·Button 
	x += width + 10;
	width = 60;
	btnOpenPath_.Create("·", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, CRect(x, y, x + width, y + height), parent_, GenOpenPathBtnID());
	btnOpenPath_.SetFont(&m_font);

	isCtrlsCreated_ = true;

	return true;
}

void CSvrProcessCtrl::CreateHeader(CWnd* parent)
{
	if (parent == NULL)
	{
		parent = AfxGetMainWnd();
	}

	int y = headerTopLeft_.y;
	int x = headerTopLeft_.x;
	int width = 200;
	int height = 25;
	header1.Create("", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	//x += width + 20;
	//width = 180;
	//header2.Create("ļ", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	x += width + 20;
	width = 480;
	header3.Create("", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	x += width + 20;
	width = 80;
	header4.Create("ID", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	x += width + 20;
	width = 120;
	header5.Create("˿", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	x += width + 20;
	width = 150;
	header6.Create("ʱ", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);

	x += width + 20;
	width = 100;
	header7.Create("", WS_CHILD | WS_VISIBLE | SS_LEFT, CRect(x, y, x + width, y + height), parent);
}

bool CSvrProcessCtrl::CheckProcessStatus()
{
	bool bStart = false;
	bool bUpdated = false;
	int pid = GetPidByCmdline1();
	string listenAddr = serverInfo_.listenAddr_;

	if (pid > 0) // Ѿ⵽̲ʱԶý
	{
		//autoStart_ = true;
	}

	if (pid != serverInfo_.pid_)
	{
		bUpdated = true;		

		if (pid == 0 && autoStart_)
		{
			//Process exited abnormally
			string alertMsg = serverInfo_.name_ + ": service not workingit will be restarted right away!";
			SendAlertMail(alertMsg);
		}
#if 0
		if (pid > 0 && autoStart_ == false)
		{
			//ֳʱԶлΪؽԶģʽ
			autoStart_ = true;
			g_log->info("Enable autoStart mode for {}", serverInfo_.name_);
		}
#endif
	}

	serverInfo_.pid_ = pid;
	
	if (pid == 0 && autoStart_)
	{
		bStart = Start();
		g_log->info("service is closed, autoStart {} {}", serverInfo_.name_, bStart);
	}

	if (bStart == false)
	{
		serverInfo_.listenAddr_ = GetListenAddrByPID1();
		GetStartupTimeByPID(serverInfo_.startupTime_);
	}

	if (pid != serverInfo_.pid_
		|| listenAddr != serverInfo_.listenAddr_)
	{
		bUpdated = true;
	}

	return bUpdated;
}

int CSvrProcessCtrl::GetPidByCmdline()
{
	string cmd;
	string processName;
	int pid = 0;

	processName = serverInfo_.processName_;
	if (processName.find(".exe") == string::npos
		|| processName.find(".exe") != processName.length() - strlen(".exe"))
	{
		processName += ".exe";
	}

	cmd = "wmic process where caption=\"";
	cmd += processName;
	cmd += "\" get commandline, processid /value";

	string output;
	PipeShellCmd(cmd, output);

	//ȡPID
	size_t pos1 = output.find(serverInfo_.commandline_);
	if (pos1 == string::npos)
	{
		return 0;
	}

	size_t pos2 = output.find("ProcessId=", pos1 + serverInfo_.commandline_.length());
	if (pos2 == string::npos)
	{
		return 0;
	}

	size_t pos3 = pos2 + strlen("ProcessId=");
	while (isspace(output[pos3]) == false && output[pos3] != '\0')
	{
		pos3++;
	}

	string strPid = output.substr(pos2 + strlen("ProcessId="), pos3 - (pos2 + strlen("ProcessId=")));
	pid = atoi(strPid.c_str());

	return pid;
}

int CSvrProcessCtrl::GetPidByCmdline1()
{
	//ʱûҵܺõİ취ȷظ commandline ҽϢ
	//minigameͬһĿ¼µ.exeļֻһʵ
	//Ŀǰʹý̵filepathҽϢ
	string processName;
	processName = serverInfo_.processName_;
	if (processName.find(".exe") == string::npos
		|| processName.find(".exe") != processName.length() - strlen(".exe"))
	{
		processName += ".exe";
	}

	//Retrieve filepath from commandline
	size_t pos = serverInfo_.commandline_.find(processName);
	if (pos == string::npos)
	{
		return 0;
	}

	
	string filepath = serverInfo_.commandline_.substr(0, pos + processName.length());

	pos = serverInfo_.commandline_.find(" ");
	string processCmd = "";
	if (pos != string::npos)
	{
		processCmd = serverInfo_.commandline_.substr(pos, serverInfo_.commandline_.length() - pos);
		//ȥλո
		processCmd.erase(0, processCmd.find_first_not_of(" "));
		processCmd.erase(processCmd.find_last_not_of(" ") + 1);
	}
	return GetPid(processName.c_str(), filepath.c_str(), processCmd.c_str());
	//int pid = GetPidByFilepath(processName.c_str(), filepath.c_str());
	
	//return pid;
	
}

bool CSvrProcessCtrl::Start()
{
	autoStart_ = true;
	g_log->info("Enabled autoStart mode for {}", serverInfo_.name_);

	if (serverInfo_.pid_ > 0)
	{
		return false;
	}

	if (::WinExec(serverInfo_.commandline_.c_str(), SW_HIDE) <= 31)
	{
		return false;
	}

	int pid = GetPidByCmdline1();
	if (pid == 0)
	{
		return false;
	}

	serverInfo_.pid_ = pid;

	Sleep(210); 
	serverInfo_.listenAddr_ = GetListenAddrByPID1();

	GetStartupTimeByPID(serverInfo_.startupTime_);	

	string alertMsg = serverInfo_.name_ + " started successfully: pid=" + to_string(pid);
	SendAlertMail(alertMsg);

	//Stop the associated conhost.exe process
	int conhostPID = GetConhostPID(pid);
	if (conhostPID > 0)
	{
		HANDLE hProcess = ::OpenProcess(PROCESS_TERMINATE, FALSE, conhostPID);
		if (hProcess != NULL)
		{
			::TerminateProcess(hProcess, 0);
			CloseHandle(hProcess);
		}
	}

	return true;
}

bool CSvrProcessCtrl::Stop(bool autoStart)
{
	if (serverInfo_.pid_ == 0)
	{
		return false;
	}

	HANDLE hProcess = ::OpenProcess(PROCESS_TERMINATE, FALSE, serverInfo_.pid_);
	if (hProcess == NULL)
	{
		return false;
	}

	bool ret = ::TerminateProcess(hProcess, 0);
	CloseHandle(hProcess);
	
	if (ret)
	{
		serverInfo_.pid_ = 0;
		serverInfo_.listenAddr_ = "";
		serverInfo_.startupTime_ = CTime();
	}

	autoStart_ = autoStart;
	if (autoStart_ == false)
	{
		g_log->info("Disabled autoStart mode for {}", serverInfo_.name_);
	}

	return ret;
}

void CSvrProcessCtrl::UpdateStatus()
{
	if (isCtrlsCreated_ == false)
	{
		return;
	}

	string strPid;
	if (serverInfo_.pid_ > 0)
	{
		strPid = to_string(serverInfo_.pid_).c_str();
	}
	textPid_.SetWindowText(strPid.c_str());
	textListenAddr_.SetWindowText(serverInfo_.listenAddr_.c_str());

	if (serverInfo_.pid_ > 0)
	{
		btnStart_.SetWindowText("ֹͣ");
	}
	else
	{
		btnStart_.SetWindowText("");
	}

	CString strStartupTime;
	if (serverInfo_.startupTime_ != 0)
	{
		strStartupTime = serverInfo_.startupTime_.Format("%Y-%m-%d %H:%M:%S");
	}
	textStartupTime_.SetWindowText(strStartupTime);	
}

string CSvrProcessCtrl::GetListenAddrByPID()
{
	if (serverInfo_.pid_ == 0)
	{
		return "";
	}

	string cmd;
	cmd = "netstat -nao -p tcp | findstr LISTENING | findstr " + to_string(serverInfo_.pid_);

	string output;
	PipeShellCmd(cmd, output);

	//ȡListening Address
	if (output.empty())
	{
		return "";
	}

	vector<string> vecLine;
	splitString(output, vecLine, "\r\n");

	for (size_t i = 0; i < vecLine.size(); i++)
	{
		vector<string> vecTemp;
		splitString(vecLine[i], vecTemp, " ");

		if (vecTemp.size() != 5)
		{
			continue;
		}

		if (atoi(vecTemp[4].c_str()) == serverInfo_.pid_)
		{
			return vecTemp[1];
		}
	}

	return "";
}

string CSvrProcessCtrl::GetListenAddrByPID1()
{
	if (serverInfo_.pid_ == 0)
	{
		return "";
	}

	string listenAddr;

	typedef  DWORD(WINAPI *PGetExtendedTcpTable)(
		PVOID pTcpTable,
		PDWORD pdwSize,
		BOOL bOrder,
		ULONG ulAf,
		TCP_TABLE_CLASS TableClass,
		ULONG   Reserved);

	HINSTANCE hLibrary = LoadLibrary("Iphlpapi.dll "); //
	PGetExtendedTcpTable pFuncGetTCPTable;
	pFuncGetTCPTable = (PGetExtendedTcpTable)GetProcAddress(hLibrary, "GetExtendedTcpTable");

	PMIB_TCPTABLE_OWNER_PID pTcpTable(NULL);
	DWORD dwSize(0);
	if (pFuncGetTCPTable(pTcpTable, &dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0) == ERROR_INSUFFICIENT_BUFFER)
	{
		pTcpTable = (MIB_TCPTABLE_OWNER_PID *)new char[dwSize];//·仺
	}

	if (pFuncGetTCPTable(pTcpTable, &dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0) != NO_ERROR)
	{
		delete pTcpTable;
		return "";
	}

	int nNum = (int)pTcpTable->dwNumEntries;	//TCPӵĿ
	for (int i = 0; i<nNum; i++)
	{
#if 0
		printf("صַ%s:%d  Զ̵ַ%s:%d  ״̬%d  ID:%d",
			inet_ntoa(*(in_addr*)& pTcpTable->table[i].dwLocalAddr),	//IP ַ
			htons(pTcpTable->table[i].dwLocalPort),						//ض˿
			inet_ntoa(*(in_addr*)& pTcpTable->table[i].dwRemoteAddr),	//ԶIPַ
			htons(pTcpTable->table[i].dwRemotePort),					//Զ̶˿
			pTcpTable->table[i].dwState,								//״̬
			pTcpTable->table[i].dwOwningPid);							//PID
#endif

		if (pTcpTable->table[i].dwOwningPid == serverInfo_.pid_ && pTcpTable->table[i].dwState == MIB_TCP_STATE_LISTEN)
		{
			listenAddr = IP2Str(ntohl(pTcpTable->table[i].dwLocalAddr));
			listenAddr += ":" + to_string(ntohs(pTcpTable->table[i].dwLocalPort));
		}
	}

	delete pTcpTable;

	return listenAddr;
}

void CSvrProcessCtrl::GetStartupTimeByPID(CTime& cStartupTime)
{
	if (serverInfo_.pid_ == 0)
	{
		return;
	}

	HANDLE hProcess = ::OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, serverInfo_.pid_);
	if (hProcess == NULL)
	{
		return;
	}

	FILETIME startupTime;
	FILETIME exitTime;
	FILETIME kernelTime;
	FILETIME userTime;
	bool rc = GetProcessTimes(hProcess, &startupTime, &exitTime, &kernelTime, &userTime);

	if (rc)
	{
		cStartupTime = CTime(startupTime);
	}
}

bool CSvrProcessCtrl::smtp_sendmail(string smtpserver, 
	string smtpport, 
	string smtpuser,
	string smtppassword, 
	string subject, 
	string message,
	string mailto_list, 
	string fileName, 
	string& errmsg)
{
	CSmtp mail;
	bool bRet = true;
	static time_t sendTime = 0;

	sendTime = time(NULL);

	try
	{
		mail.SetSMTPServer(smtpserver.c_str(), atoi(smtpport.c_str()));
		mail.SetLogin(smtpuser.c_str());
		mail.SetPassword(smtppassword.c_str());
		mail.SetSenderName("26300 MiniGame");
		mail.SetSenderMail(smtpuser.c_str());
		mail.SetReplyTo(smtpuser.c_str());

		mail.SetXPriority(XPRIORITY_NORMAL);
		mail.SetXMailer("The Bat! (v3.02) Professional");

		mail.SetSubject(subject.c_str());
		mail.AddMsgLine(message.c_str());


		if (mailto_list.empty())
		{
			return false;
		}

		if (!fileName.empty())
		{
			mail.AddAttachment(fileName.c_str());
		}

		if (mailto_list[mailto_list.length() - 1] != ';')
		{
			mailto_list += ';';
		}

		string strMailTo = mailto_list;

		int pos1 = 0;
		int pos2 = 1;
		string mailto;

		while (pos2 != string::npos)
		{
			pos2 = strMailTo.find(';', pos1);

			if (pos2 != string::npos && pos2 > pos1)
			{
				mailto = strMailTo.substr(pos1, pos2 - pos1);

				mail.AddRecipient(mailto.c_str());

				pos1 = pos2 + 1;
			}
		}

		mail.Send();
	}
	catch (ECSmtp e)
	{
		bRet = false;
		errmsg = e.GetErrorText();
	}

	return bRet;
}

void CSvrProcessCtrl::SendAlertMail(string message, string subject)
{
	static time_t lastTime = time(NULL);
	time_t curTime = time(NULL);
	string errmsg;

	g_log->info(message);

	if (curTime - lastTime < alertMailSetting_.minAlertInterval_
		&& curTime - lastTime != 0)
	{
		return;
	}

	if (!CSvrProcessCtrl::smtp_sendmail(alertMailSetting_.smtpServer_,
		alertMailSetting_.smtpPort_,
		alertMailSetting_.smtpUser_,
		alertMailSetting_.smtpPassword_,
		subject,
		message,
		alertMailSetting_.mailTo_,
		"",
		errmsg))
	{
		g_log->error("Sending alert email error: " + errmsg);
	}	
}