#include "Stdafx.h"
#include "slog.h"
#include <iostream>

const static uint32_t MAX_LOG_FILE_SIZE = 52428800;		//50MB
const static uint32_t MAX_LOG_FILE_COUNT = 20;			//־ļ

extern CString GetModuleDir();

SLog::SLog()
{

}

SLog::~SLog()
{

}

bool SLog::init()
{
	try {
		spdlog::set_async_mode(8192, spdlog::async_overflow_policy::discard_log_msg, nullptr, std::chrono::milliseconds(500));

		std::vector<spdlog::sink_ptr> sinks;		
        std::string logFile = AfxGetAppName();
        logFile = "logs\\" + logFile;
        sinks.push_back(std::make_shared<spdlog::sinks::daily_file_sink_mt>(logFile, 23, 59));
        //sinks.push_back(std::make_shared<spdlog::sinks::rotating_file_sink_mt>("logs/gamesvr", MAX_LOG_FILE_SIZE, MAX_LOG_FILE_COUNT));
		logger_ = std::make_shared<spdlog::logger>(AfxGetAppName(), begin(sinks), end(sinks));
		spdlog::register_logger(logger_); 

		spdlog::set_pattern("%Y-%m-%d %H:%M:%S.%e [%l]: %v");
		spdlog::set_level(spdlog::level::debug);
		logger_->flush_on(spdlog::level::debug);
	}
	catch (const spdlog::spdlog_ex& ex) {
		std::cout << "Log initialization failed: " << ex.what() << std::endl;
		return false;
	}
	catch (...)
	{

	}

	return true;
}

extern "C" __declspec(dllexport) void*  GetLogger()
{
	return (void*)&g_log;
}